package no.fjas.wspv.validators;

import no.fjas.wspv.ValidationException;
import no.fjas.wspv.ValidatorException;
import no.fjas.wspv.validators.EnumValidator;

public class EnumValidatorTest extends AbstractValidatorTest {
	
	public void setUp() {
		super.setUp();
		validator = new EnumValidator();
	}
	
	public void testNullParameter() {
		super.testNullParameter();
		
		try {
			mockupElement.setTextContent("");
			validator.addParameter("constant", null);
			validator.validate(mockupElement);
			fail();
		} catch (ValidatorException e) {
			assertTrue(true);
		} catch (ValidationException e) {
			
		}
	}
	
	public void testLegalValues() {
		try {
			validator.addParameter("constant", "HIGH");
			validator.addParameter("constant", "MEDIUM");
			validator.addParameter("constant", "LOW");
			
			mockupElement.setTextContent("HIGH");
			validator.validate(mockupElement);
			mockupElement.setTextContent("MEDIUM");
			validator.validate(mockupElement);
			mockupElement.setTextContent("LOW");
			validator.validate(mockupElement);
		} catch (ValidationException e) {
			e.printStackTrace();
			fail();
		}
	}
	
	public void testInvalidValue() {
		try {
			validator.addParameter("constant", "HIGH");
			validator.addParameter("constant", "MEDIUM");
			validator.addParameter("constant", "LOW");
			
			mockupElement.setTextContent("MED");
			validator.validate(mockupElement);
			fail();
		} catch (ValidationException e) {
			assertEquals(e.getMessage(), "Invalid value");
			assertTrue(true);
		}
	}
}
