package no.fjas.wspv.validators;

import no.fjas.wspv.validators.RegexValidator;

/**
 * Validates norwegian license plates for cars. A norwegian license plate
 * consists of 2 letter a dash and then 5 digits. E.g. AB-12345
 * 
 * @author <a href="mailto:henning _at_ fjas.no">Henning Jensen</a> *
 */
public class LicensePlateNoValidator extends RegexValidator {

	private final static String LICENSE_PLATE_NORWEGIAN = "[A-Z]{2}-\\d{5}$";

	public LicensePlateNoValidator() {
		setExpression(LICENSE_PLATE_NORWEGIAN);
		setCaseSensitive(false);
	}

}
