package no.fjas.wspv.examples.axis2;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class BookService {
	private Map<String, Book> bookList = new HashMap<String, Book>();

	public BookService() {
		Book book1 = new Book();
		book1.setId(1);
		book1.setAuthor("Dan Diephouse");
		book1.setTitle("Using XFire");
		book1.setIsbn("12-3456-789-0");
		book1.setPrice(49.99);
		
		Book book2 = new Book();
		book2.setId(2);
		book2.setAuthor("J. K. Rowling");
		book2.setTitle("Harry Potter and the Deathly Hallows ");
		book2.setIsbn("0545010225");
		book2.setPrice(34.99);
				
		bookList.put(book1.getIsbn(), book1);
		bookList.put(book2.getIsbn(), book2);
	}

	public Book[] getBooks() {
		Collection<Book> books = bookList.values();
		return (Book[]) books.toArray(new Book[books.size()]);
	}

	public Book findBook(String isbn) throws BookException {
		Book result = bookList.get(isbn);
		if (result != null)
			return result;
		else
			throw new BookException("Book does not exists");
	}

	public Book getBook(int id) throws BookException {
		Iterator<Book> iter = bookList.values().iterator();
		while (iter.hasNext()) {
			Book book = iter.next();
			if (book.getId() == id)
				return book;
		}

		throw new BookException("Book does not exists");
	}

	public Book[] findBooksByMaxPrice(double price) {
		Collection<Book> bookCollection = bookList.values();
		Iterator<Book> iter = bookCollection.iterator();
		Book[] books = new Book[bookCollection.size()];
		int counter = 0;
		while (iter.hasNext()) {
			Book book = iter.next();
			if (book.getPrice() >= price)
				books[counter++] = book;
		}
		return books;
	}

	public void addBook(Book book) {
		bookList.put(book.getIsbn(), book);
	}

}
