package no.fjas.wspv.xfire.service;

import java.net.MalformedURLException;

import org.codehaus.xfire.client.Client;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.service.binding.ObjectServiceFactory;
import org.codehaus.xfire.util.dom.DOMInHandler;

/**
 * @author <a href="mailto:henning _at_ fjas.no">Henning Jensen</a>
 */
public class BookClient {
	public static void main(String args[]) {
		String serviceURL = "http://localhost:8080/xfire-book/services/BookService";
		Service serviceModel = new ObjectServiceFactory().create(
				BookService.class, null,
				"http://xfire.codehaus.org/BookService", null);

		XFireProxyFactory serviceFactory = new XFireProxyFactory();

		try {
			BookService service = (BookService) serviceFactory.create(
					serviceModel, serviceURL);
			Client client = Client.getInstance(service);
			client.addInHandler(new DOMInHandler());

			Book[] books = service.getBooks();
			System.out.println("BOOKS:");

			for (int i = 0; i < books.length; i++) {
				System.out.println(books[i].getTitle());
			}

			service.findBook("115-245-152-2");

		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (BookException e) {
			System.out.print(e.getFaultInfo().getDetailMessage());
		}
	}
}
