package no.fjas.wspv.xfire.service;


/**
 * 
 * Service finding books
 * 
 * @author <a href="mailto:henning _at_ fjas.no">Henning Jensen</a>
 * 
 */
public interface BookService {

	public Book getBook(int id) throws BookException;

	public Book[] suggestBookByMaxPrice(double price) throws BookException;
	
	/**
	 * returns array of the books
	 * 
	 * @return all books
	 */
	public Book[] getBooks();

	/**
	 * Find book by id
	 * 
	 * @param isbn
	 *            isbn number
	 * @return found book
	 * @throws BookException
	 *             cos tam
	 */
	public Book findBook(String isbn) throws BookException;
}
