package no.fjas.wspv.xfire.service;


/**
 * @author <a href="mailto:henning _at_ fjas.no">Henning Jensen</a>
 */
public class BookServiceImpl implements BookService {
	private Book onlyBook;

	public BookServiceImpl() {
		onlyBook = new Book();
		onlyBook.setId(1);
		onlyBook.setAuthor("Dan Diephouse");
		onlyBook.setTitle("Using XFire");
		onlyBook.setIsbn("12-3456-789-0");
		onlyBook.setPrice(50.40);
	}

	public Book getBook(int id) throws BookException {
		if (onlyBook.getId() == id) {
			return onlyBook;
		} else {
			throw new BookException("Book does not exist", new BookExceptionDetail("NOT_EXIST", "Can't find book"));
		}
	}
	
	public Book[] getBooks() {
		return new Book[] { onlyBook };
	}

	public Book findBook(String isbn) throws BookException {
		if (isbn.equals(onlyBook.getIsbn()))
			return onlyBook;

		throw new BookException("Book does not exist", new BookExceptionDetail(
				"NOT_EXIST", "Can't find book"));
	}

	public Book[] suggestBookByMaxPrice(double price) throws BookException {
		Book[] result = new Book[5];
		if (onlyBook.getPrice() < price) {
			result[0] = onlyBook;
		}
		return result;
	}

}